//
// Sample program: semmx.sc
//
// Demo: Create 3 tasks, have 2 block behind a semaphore, have 1 wait
//       for a key. When keystroke arrives signal sem allowing next
//       highest priority waiter to proceed whose job is to signal
//       the sem a second time and let the last remaining task proceed.
//
// (C) Copyright 1998, David Moore.
//


#include "jxlib.sh"

module test;

  declare;
     byte stk[1023];
     byte stktop;

     byte stk2[511];
     byte stktop2;

     byte stk3[511];
     byte stktop3;

     byte task1name "task_1\0";
     byte task2name "task_2\0";
     byte task3name "task_3\0";

     byte str_start    "task_3: begin semaphore test...\n\0";
     byte str_t3signal "task_3: Hit a key to signal semaphore and unblock tasks 1+2.\n\0";
     byte str_t3ok     "task_3: end semaphore test\n\0";

     byte str_t1wait "task_1: wait for semaphore\n\0";
     byte str_t1ok   "task_1: got semaphore - now signal for task2\n\0";

     byte str_t2wait "task_2: wait for semaphore\n\0";
     byte str_t2ok   "task_2: got semaphore\n\0";

     byte str_fail   "main:failed to get sem\n\0";

     byte semdescr "semtst01";
     long sts;

     byte key;
     long tid;

     public proc main( void );
     public proc main_cli( void );
     public proc task1( void );
     public proc task2( void );
     public proc task3( void );

  enddeclare;

  public proc main( void );

    tid = lib_taskcreate( ptr task3, ptr stktop3, 27, ptr task3name );
    tid = lib_taskcreate( ptr task2, ptr stktop2, 29, ptr task2name );
    tid = lib_taskcreate( ptr task1, ptr stktop, 28, ptr task1name );

  endproc;



  public proc main_cli( void );
  endproc;



  public proc task1( void );

     lib_write( ptr str_t1wait );
     lib_waitsem( ptr semdescr );

     // don't get here until task 3 signals semaphore
     lib_write( ptr str_t1ok );

     // task 3 still blocked this send signal to unblock it
     lib_signalsem( ptr semdescr );

     lib_taskdeletev();

  endproc;    




  public proc task2( void );

    lib_write( ptr str_t2wait );

    lib_waitsem( ptr semdescr );

    lib_write( ptr str_t2ok );

    lib_taskdeletev();

  endproc;




  public proc task3( void );

    lib_write( ptr str_start );

    sts = lib_getsem( 1, ptr semdescr );

    lib_waitsem( ptr semdescr );

    lib_write( ptr str_t3signal );

    key = lib_waitkey();
        
    lib_signalsem( ptr semdescr );

    lib_write( ptr str_t3ok );
        
    lib_taskdeletev();

  endproc;    




endmodule;

